<?php
/*****************************************************************************/
/* Karma.php                                                                 */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

$karmaphpver = 'YaBB SE 1.5.1';

function ModifyKarma()
{
	global $modSettings, $username, $settings, $db_prefix, $karmaAction, $uid, $ID_MEMBER, $HTTP_REFERER, $txt;
	global $doLimitOne;

	/* if the mod is disabled, error */
	if ($modSettings['karmaMode'] == '0')
		fatal_error($txt['yse63']);

	/* if we've defined any member groups to restrict it to, and if you're
		not part of one of said membergroups, kick you're ass to the curb */
	if ($modSettings['karmaMemberGroups'][0] != '' && sizeof($modSettings['karmaMemberGroups']) >= 1 && !in_array($settings[7], $modSettings['karmaMemberGroups']) && $settings[7] == 'Administrator' && $settings[7] == 'Global Moderator')
		fatal_error($txt[1]);

	/* if you're a guest, blow you off */
	if ($username == 'Guest')
		fatal_error($txt[1]);

	/* if you don't have enough posts, tough luck */
	if ($settings[6] < $modSettings['karmaMinPosts'])
		fatal_error("$txt[yse60]$modSettings[karmaMinPosts].");

	/* and you can't modify you're own punk! */
	if ($uid == $ID_MEMBER)
		fatal_error("$txt[yse61]");

	$dir = (strcasecmp("applaud", "$karmaAction") ? '-' : '+');
	$nowtime = time();
	$request = mysql_query("DELETE FROM {$db_prefix}log_karma WHERE ($nowtime-logTime)>($modSettings[karmaWaitTime]*3600);") or database_error(__FILE__, __LINE__);

	$change = 0;

	if ($modSettings['karmaTimeRestrictAdmins'] || $settings[7] != 'Administrator')
	{
		$request = mysql_query("SELECT action FROM {$db_prefix}log_karma WHERE (ID_TARGET='$uid' && ID_EXECUTOR='$ID_MEMBER') LIMIT 1;") or database_error(__FILE__, __LINE__);
		if (mysql_num_rows($request) == 0) // there are no entries for you and that user logged
		{
			$request = mysql_query("INSERT INTO {$db_prefix}log_karma (action, ID_TARGET, ID_EXECUTOR, logTime) VALUES ('$dir', '$uid', '$ID_MEMBER', '$nowtime');") or database_error(__FILE__, __LINE__);
			$change = 1;
		}
		else
		{
			$row = mysql_fetch_row($request);
			if ($row[0] == $dir)	// if you're trying to repeat
				fatal_error("$txt[yse62] $modSettings[karmaWaitTime] $txt[578].");
			else
			{
				$request = mysql_query ("UPDATE {$db_prefix}log_karma SET action='$dir', logTime='$nowtime' WHERE (ID_TARGET='$uid' && ID_EXECUTOR='$ID_MEMBER') $doLimitOne;") or database_error(__FILE__, __LINE__);
				$change = 2;
			}
		}

	}
	else
	{
		$request = mysql_query("UPDATE {$db_prefix}log_karma SET action='$dir', logTime='$nowtime' WHERE (ID_TARGET='$uid' && ID_EXECUTOR='$ID_MEMBER') $doLimitOne;") or database_error(__FILE__, __LINE__);
		if (mysql_affected_rows() == 0)
			$request = mysql_query("INSERT INTO {$db_prefix}log_karma (action, ID_TARGET, ID_EXECUTOR, logTime) VALUES ('$dir', '$uid', '$ID_MEMBER', '$nowtime');") or database_error(__FILE__, __LINE__);
		$change = 1;
	}

	if ($change != 0)
	{
		$field = (($dir == '+') ? 'karmaGood' : 'karmaBad');
		$request = mysql_query("UPDATE {$db_prefix}members SET $field=$field+$change WHERE ID_MEMBER='$uid' $doLimitOne;") or database_error(__FILE__, __LINE__);
	}

	echo '<script>history.go(-1)</script>';
	obExit();
}

?>